//+------------------------------------------------------------------+
//|                                                    MyFirstEA.mq4 |
//|                                                            Gypsy |
//|                                                             none |
//+------------------------------------------------------------------+
#property copyright "Gypsy"
#property link      "none"
#property version   "1.00"
#property strict
//-------------------------------------------------------------------------------------------------+++++
/*
Global Order Inputs necessary for placing all trades
*/
//-------------------------------------------------------------------------------------------------+++++
extern string GlobalOrderInputs="";//**** Global Order Inputs ****
extern double EA_LotSize=0.01;//Lot size for the trade
extern int    EA_Slippage=0;//Slippage
extern int    EA_StopLoss=50;//StopLoss
extern int    EA_TakeProfit=100;//TakeProfit
extern string EA_Comment="My First EA";//Comment
extern int    EA_MagicNumber=0001;//Magic Number
extern color  EA_ArrowColor=clrNONE;//Arrow Color
extern string EA_break="";//=======================================
//-------------------------------------------------------------------------------------------------+++++
/*
Global Inputs for the chosen indicator
Look in the Documentation Section for the Indicator you wish to use and change this section to reflect
the parameters for the chosen indicator.
*/
//-------------------------------------------------------------------------------------------------+++++
//Fast Moving Average
extern string Fast_MovingAverage="";//**** Fast Moving Average Indicator **** 
extern int    Fast_MAperiod=10;//Fast Moving Average Period
extern int    Fast_MAindshift=0;//Fast Moving Average Indicator Shift
extern string Choose_FastMA_CalcMethod="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";
extern int    Fast_MAcalcMethod=1;//Calculation Method 
extern string Choose_FastMA_AppliedPrice="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Fast_MAappliedprice=0;//Applied Price
extern int    Fast_MAbufferShift=1;//Fast Moving Average Buffer Shift
extern string Fast_break="";//=======================================
//-------------------------------------------------------------------------------------------------+++++
//Slow Moving Average
extern string Slow_MovingAverage="";//**** Slow Moving Average Indicator **** 
extern int    Slow_MAperiod=21;//Slow Moving Average Period
extern int    Slow_MAindshift=0;//Slow Moving Average Indicator Shift
extern string Choose_SlowMA_CalcMethod="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";
extern int    Slow_MAcalcMethod=1;//Calculation Method 
extern string Choose_SlowMA_AppliedPrice="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Slow_MAappliedprice=0;//Applied Price
extern int    Slow_MAbufferShift=1;//Slow Moving Average Buffer Shift
extern string Slow_break="";//=======================================
//-------------------------------------------------------------------------------------------------+++++
//TrailStop
//-------------------------------------------------------------------------------------------------+++++
extern string TrailStop="";//**** Choose - True or False ****
extern bool   Use_TrailStop=false;
extern string TrailStopbreak="";//=======================================
//-------------------------------------------------------------------------------------------------+++++
//Global Declarations used throughout the program
//+++++
//Declaration for Adjust for Brokers and StopLoss/TakeProfit calculations
double pips=0;
//+++++
//Order Ticket Declarations
int OpenLongTicket=0;//Open Long ticket declaration
int OpenShortTicket=0;//Open Short ticket declaration  
int CloseLongTicket=0;//Close Long Ticket declaration
int CloseShortTicket=0;//Close Short Ticket declaration
//+++++
//TrailStop Declarations
int LongTicketModify=0;//Modify Long ticket
int ShortTicketModify=0;//Modify Short ticket
//-------------------------------------------------------------------------------------------------+++++
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//Adjust for Brokers Digits
   double ticksize=MarketInfo(Symbol(),MODE_TICKSIZE);
   if(ticksize==0.00001 || ticksize==0.001)
      pips=ticksize*10;
   else pips=ticksize;

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
/*
Not used in this program
*/
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//Function calls on each tick
   if(IsNewBar())//Checks for a new bar on every tick
     {
      Indicator();//Calls the indicator funtion if there is a new bar
     }
   if(Use_TrailStop==true)//Check for true or false
     {
      TrailStop();//Uses the TrailStop function if set to true
     }
  }//End of Function
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsNewBar()
  {
//Checks for a new bar everytime the function is called
   static int BarsOnChart=0;
   if(Bars==BarsOnChart)
      return (false);
   BarsOnChart=Bars;
   return(true);
  }//End of Function
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Trade(int TradeDecision)
  {
//-------------------------------------------------------------------------------------------------+++++
//StopLoss and TakeProfit Calculations for Long Orders
   double StopLoss_Long=Ask-NormalizeDouble(EA_StopLoss*pips,Digits);
   double TakeProfit_Long=Ask+NormalizeDouble(EA_TakeProfit*pips,Digits);

//StopLoss and TakeProfit Calculations for Short Orders
   double StopLoss_Short=Bid+NormalizeDouble(EA_StopLoss*pips,Digits);
   double TakeProfit_Short=Bid-NormalizeDouble(EA_TakeProfit*pips,Digits);
//-------------------------------------------------------------------------------------------------+++++
   if(OrdersTotal()==0)//Check to see if there is a Order already open
     {
      if(TradeDecision==1)//Calls the Indicator function for a Trade Descision, 1 = Place Long Trade
        {
         //Places the Long Trade
         OpenLongTicket=OrderSend(Symbol(),OP_BUY,EA_LotSize,Ask,EA_Slippage,StopLoss_Long,TakeProfit_Long,EA_Comment,EA_MagicNumber,EA_ArrowColor);
         if(OpenLongTicket<0)
            //If the Trade Fails, a Alert Window will open on the screen informing the trader of the Error code
           {
            Alert("Long Order Error Occured : "+ErrorDescription(GetLastError()));
           }
         if(OpenLongTicket>0)
            //If the Trade is Opened, a Alert Window will Open informing the trader that the trade has been opened successfully
            //also the trade information will be printed in the experts tab or in the journal tab if testing.
           {
            Print("-------------------------------------------------------------------------------------------------");
            Print("Arrow Color..",ColorToString(EA_ArrowColor,true));
            Print("Magic Number..",IntegerToString(EA_MagicNumber,Digits));
            Print("Comment..",EA_Comment);
            Print("Long Position TakeProfit...",DoubleToStr(TakeProfit_Long,Digits),"   ",
                  "Potential Profit...",DoubleToStr(TakeProfit_Long-Ask,Digits),
                  ".pips");
            Print("Long Position StopLoss...",DoubleToStr(StopLoss_Long,Digits),"   ",
                  "Potential Loss...",DoubleToStr(Ask-StopLoss_Long,Digits),
                  ".pips");
            Print("Slippage..",DoubleToStr(EA_Slippage,0));
            Print("Lot Size..",DoubleToStr(OrderLots(),2));
            Print("Order Open Price...",DoubleToStr(Ask,Digits));
            Print("Order Symbol...",Symbol());
            Print("New Long Order Placed");
            Alert("New Long Order Placed");
            Print("-------------------------------------------------------------------------------------------------");

           }
        }
      //-------------------------------------------------------------------------------------------------+++++
      //New Short Order
      if(TradeDecision==2)//Calls the Indicator function for a Trade Descision, 2 = Place Short Trade
        {
         //Places the Short Trade
         OpenShortTicket=OrderSend(Symbol(),OP_SELL,EA_LotSize,Bid,EA_Slippage,StopLoss_Short,TakeProfit_Short,EA_Comment,EA_MagicNumber,EA_ArrowColor);
         //Places the Short Trade
         if(OpenShortTicket<0)
            //If the Trade Fails, a Alert Window will open on the screen informing the trader of the Error code
           {
            Alert("Short Order Error Occured : "+ErrorDescription(GetLastError()));
           }
         if(OpenShortTicket>0)
            //If the Trade is Opened, a Alert Window will Open informing the trader that the trade has been opened successfully
            //also the trade information will be printed in the experts tab or in the journal tab if testing.
           {
            Print("-------------------------------------------------------------------------------------------------");
            Print("Arrow Color..",ColorToString(EA_ArrowColor,true));
            Print("Magic Number..",IntegerToString(EA_MagicNumber,Digits));
            Print("Comment..",EA_Comment);
            Print("Short Position TakeProfit...",DoubleToStr(TakeProfit_Long,Digits),"   ",
                  "Potential Profit...",DoubleToStr(Bid-TakeProfit_Long,Digits),
                  ".pips");

            Print("Short Position StopLoss...",DoubleToStr(StopLoss_Short,Digits),"   ",
                  "Potential Loss...",DoubleToStr(StopLoss_Short-Bid,Digits),
                  ".pips");
            Print("Slippage..",DoubleToStr(EA_Slippage,0));
            Print("Lots..",DoubleToStr(OrderLots(),2));
            Print("Order Open Price...",DoubleToStr(Bid,Digits));
            Print("Order Symbol...",Symbol());
            Print("New Short Order Placed");
            Alert("New Short Order Placed");
            Print("-------------------------------------------------------------------------------------------------");
           }
        }
     }
   if(OrdersTotal()>0)//Checks for orders already opened
     {
      if(TradeDecision==2)//Calls the Indicator function for a Trade Descision, 2 = Close the Long Trade
        {
         //Loop for selecting the Long ticket
         for(int i=OrdersTotal()-1;i>=0;i--)//Loop in reverse
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))//Select trades by position
               if(OrderMagicNumber()==EA_MagicNumber)//Magic number matches
                  if(OrderComment()==EA_Comment)//Comment matches
                     if(OrderSymbol()==Symbol())//Symbol matches
                        if(OrderType()==OP_BUY)//Order type is a Long Order
                          {
                           Print("-------------------------------------------------------------------------------------------------");
                           //Closes the Long order
                           CloseLongTicket=OrderClose(OrderTicket(),OrderLots(),Bid,EA_Slippage,EA_ArrowColor);
                           if(CloseLongTicket<0)
                              //If the Close ticket Fails, a Alert Window will open on the screen informing the trader of the Error code
                             {
                              Alert("Long Order was not Closed..Error  : "+ErrorDescription(GetLastError()));
                             }
                           if(CloseLongTicket>0)
                              //If the ticket is closed, a Alert Window will Open informing the trader that the trade has been closed successfully
                              //also the trade information will be printed in the experts tab or in the journal tab if testing.
                             {
                              if(Bid<OrderOpenPrice())
                                {
                                 Print("Loss...",DoubleToStr(OrderOpenPrice()-Bid,Digits),".pips");
                                }
                              if(Bid>OrderOpenPrice())
                                {
                                 Print("Profit..",DoubleToStr(Bid-OrderOpenPrice(),Digits),".pips");
                                }
                              Print("Close Order Price...",DoubleToStr(Bid,Digits));
                              Print("Order Symbol...",Symbol());
                              Print("Long Order was closed successfully");
                              Alert("Long Order was closed successfully");
                              Print("-------------------------------------------------------------------------------------------------");
                             }
                          }
        }
      //-------------------------------------------------------------------------------------------------+++++
      //Short   
      if(TradeDecision==1)//Calls the Indicator function for a Trade Descision, 1 = Close the Short Trade
        {
         //Loop for selecting the Short Ticket
         for(int i=OrdersTotal()-1;i>=0;i--)//Loop in reverse
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))//Select trades by position
               if(OrderMagicNumber()==EA_MagicNumber)//Magic number matches
                  if(OrderComment()==EA_Comment)//Comment matches
                     if(OrderSymbol()==Symbol())//Symbol matches
                        if(OrderType()==OP_SELL)//Order type is a Long Order
                          {
                           Print("-------------------------------------------------------------------------------------------------");
                           CloseShortTicket=OrderClose(OrderTicket(),OrderLots(),Ask,EA_Slippage,EA_ArrowColor);
                           if(CloseShortTicket<0)
                              //If the Close ticket Fails, a Alert Window will open on the screen informing the trader of the Error code
                             {
                              Alert("Short Order was not Closed..Error  : "+ErrorDescription(GetLastError()));
                             }
                           if(CloseShortTicket>0)
                              //If the ticket is closed, a Alert Window will Open informing the trader that the trade has been closed successfully
                              //also the trade information will be printed in the experts tab or in the journal tab if testing.
                             {
                              if(Ask>OrderOpenPrice())
                                {
                                 Print("Loss...",DoubleToStr(Ask-OrderOpenPrice(),Digits),".pips");
                                }
                              if(Ask<OrderOpenPrice())
                                {
                                 Print("Profit..",DoubleToStr(OrderOpenPrice()-Ask,Digits),".pips");
                                }
                              Print("Close Order Price...",DoubleToStr(Ask,Digits));
                              Print("Order Symbol...",Symbol());
                              Print("Short Order was closed successfully");
                              Alert("Short Order was closed successfully");
                              Print("-------------------------------------------------------------------------------------------------");
                             }
                          }
        }
     }
  }//End of Function
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Indicator()
  {
/*
  This fuction is used to determine the trade placement according to the Indicator chosen.
  Go to the Documentation section and copy/paste the chosen indicator into the area below
  */
//-------------------------------------------------------------------------------------------------+++++
//Moving Average Indicator
//-------------------------------------------------------------------------------------------------+++++
   double Fast_MA=iMA(NULL,0,Fast_MAperiod,Fast_MAindshift,Fast_MAcalcMethod,Fast_MAappliedprice,Fast_MAbufferShift);
   double Slow_MA=iMA(NULL,0,Slow_MAperiod,Slow_MAindshift,Slow_MAcalcMethod,Slow_MAappliedprice,Slow_MAbufferShift);
//-------------------------------------------------------------------------------------------------+++++
   if(OrdersTotal()==0)//Check to make sure no orders are open
      //if no orders are present continue
     {
      if(Fast_MA>Slow_MA){Trade(1);}//Sends the placement decision to the Trade Fuction - 1 = place a long trade
      if(Fast_MA<Slow_MA){Trade(2);}//Sends the placement decision to the Trade Fuction - 2 = place a short trade
     }
   if(OrdersTotal()>0)//Check to see if there is a Order already open
      //if there are orders present continue
     {
      if(Fast_MA<Slow_MA){Trade(2);}//Sends the trade close decision to the Trade Fuction - 2 = close the long trade
      if(Fast_MA>Slow_MA){Trade(1);}//Sends the trade close decision to the Trade Fuction - 1 = close the short trade
     }
  }
//+------------------------------------------------------------------+
//TrailStop
//+------------------------------------------------------------------+
void TrailStop()
  {
//-------------------------------------------------------------------------------------------------+++++
//TrailStopLoss Calculations
   double LongTrailingStopLoss=Ask-NormalizeDouble(EA_StopLoss*pips,Digits);
   double ShortTrailingStopLoss=Bid+NormalizeDouble(EA_StopLoss*pips,Digits);
//-------------------------------------------------------------------------------------------------+++++
//Long
   if(OrdersTotal()>0)//Check to see if there is a Order already open
     {
      if(Bid>OrderOpenPrice())
        {
         //Loop for selecting the Long ticket
         for(int i=OrdersTotal()-1;i>=0;i--)//Loop in reverse
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))//Select trades by position
               if(OrderMagicNumber()==EA_MagicNumber)//Magic number matches
                  if(OrderComment()==EA_Comment)//Comment matches
                     if(OrderSymbol()==Symbol())//Symbol matches
                        if(OrderType()==OP_BUY)//Order type is a Long Order
                           if(LongTrailingStopLoss>OrderStopLoss())
                             {
                              Print("-------------------------------------------------------------------------------------------------");
                              //If the Trailing StopLoss is Greater than the Order StopLoss change the StopLoss to the new Trailing StopLoss
                              LongTicketModify=OrderModify(OrderTicket(),OrderOpenPrice(),LongTrailingStopLoss,OrderTakeProfit(),0,EA_ArrowColor);
                              if(LongTicketModify<0)
                                 //If the TrailStop Fails, a Alert Window will open on the screen informing the trader of the Error code
                                {
                                 Alert("TrailStop - Long Order Modify..Error  : "+ErrorDescription(GetLastError()));
                                }
                              //If the StopLoss is modified, a Alert Window will Open informing the trader that the StopLoss has been modified and
                              //also the new trade information will be printed in the experts tab or in the journal tab if testing.
                              if(LongTrailingStopLoss<OrderOpenPrice())
                                {
                                 Print("Long Order Modify - New StopLoss...",DoubleToStr(LongTrailingStopLoss,Digits),"   ",
                                       "Potential Loss...",DoubleToStr(OrderOpenPrice()-LongTrailingStopLoss,Digits),
                                       ".pips");
                                 Alert("TrailStop - Long Order Modify..Successful");
                                 Print("-------------------------------------------------------------------------------------------------");
                                }
                              if(OrderOpenPrice()<LongTrailingStopLoss)
                                {
                                 Print("Long Order Modify - New StopLoss...",DoubleToStr(LongTrailingStopLoss,Digits),"   ",
                                       "Profit Locked In...",DoubleToStr(LongTrailingStopLoss-OrderOpenPrice(),Digits),
                                       ".pips");
                                 Alert("TrailStop - Long Order Modify..Successful");
                                 Print("-------------------------------------------------------------------------------------------------");
                                }
                             }
        }
      //-------------------------------------------------------------------------------------------------+++++
      //Short
      if(Ask<OrderOpenPrice())
        {
         //Loop for selecting the Short Ticket
         for(int i=OrdersTotal()-1;i>=0;i--)//Loop in reverse
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))//Select trades by position
               if(OrderMagicNumber()==EA_MagicNumber)//Magic number matches
                  if(OrderComment()==EA_Comment)//Comment matches
                     if(OrderSymbol()==Symbol())//Symbol matches
                        if(OrderType()==OP_SELL)//Order type is a Long Order
                           if(ShortTrailingStopLoss<OrderStopLoss())
                             {
                              Print("-------------------------------------------------------------------------------------------------");
                              //If the Trailing StopLoss is Less than the Order StopLoss change the StopLoss to the new Trailing StopLoss
                              ShortTicketModify=OrderModify(OrderTicket(),OrderOpenPrice(),ShortTrailingStopLoss,OrderTakeProfit(),0,EA_ArrowColor);
                              if(ShortTicketModify<0)
                                 //If the TrailStop Fails, a Alert Window will open on the screen informing the trader of the Error code
                                {
                                 Alert("TrailStop - Short Order Modify..Error  : "+ErrorDescription(GetLastError()));
                                }
                              //If the StopLoss is modified, a Alert Window will Open informing the trader that the StopLoss has been modified and
                              //also the new trade information will be printed in the experts tab or in the journal tab if testing.
                              if(ShortTrailingStopLoss>OrderOpenPrice())
                                {
                                 Print("Short Order Modify - New StopLoss...",DoubleToStr(ShortTrailingStopLoss,Digits),"   ",
                                       "Potential Loss...",DoubleToStr(ShortTrailingStopLoss-OrderOpenPrice(),Digits),
                                       ".pips");
                                 Alert("TrailStop - Short Order Modify..Successful");
                                 Print("-------------------------------------------------------------------------------------------------");
                                }
                              if(OrderOpenPrice()>ShortTrailingStopLoss)
                                {
                                 Print("Short Order Modify - New StopLoss...",DoubleToStr(ShortTrailingStopLoss,Digits),"   ",
                                       "Profit Locked In...",DoubleToStr(OrderOpenPrice()-ShortTrailingStopLoss,Digits),
                                       ".pips");
                                 Alert("TrailStop - Short Order Modify..Successful");
                                 Print("-------------------------------------------------------------------------------------------------");
                                }
                             }
        }
     }
  }//End of the Function
//+------------------------------------------------------------------+
//| return error description                                         |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
//Displays the Error Code and description of the code
   string error_string;
   switch(error_code)
     {
      //---- codes returned from trade server
      case 0:
      case 1:   error_string="no error";                                                  break;
      case 2:   error_string="common error";                                              break;
      case 3:   error_string="invalid trade parameters";                                  break;
      case 4:   error_string="trade server is busy";                                      break;
      case 5:   error_string="old version of the client terminal";                        break;
      case 6:   error_string="no connection with trade server";                           break;
      case 7:   error_string="not enough rights";                                         break;
      case 8:   error_string="too frequent requests";                                     break;
      case 9:   error_string="malfunctional trade operation";                             break;
      case 64:  error_string="account disabled";                                          break;
      case 65:  error_string="invalid account";                                           break;
      case 128: error_string="trade timeout";                                             break;
      case 129: error_string="invalid price";                                             break;
      case 130: error_string="invalid stops";                                             break;
      case 131: error_string="invalid trade volume";                                      break;
      case 132: error_string="market is closed";                                          break;
      case 133: error_string="trade is disabled";                                         break;
      case 134: error_string="not enough money";                                          break;
      case 135: error_string="price changed";                                             break;
      case 136: error_string="off quotes";                                                break;
      case 137: error_string="broker is busy";                                            break;
      case 138: error_string="requote";                                                   break;
      case 139: error_string="order is locked";                                           break;
      case 140: error_string="long positions only allowed";                               break;
      case 141: error_string="too many requests";                                         break;
      case 145: error_string="modification denied because order too close to market";     break;
      case 146: error_string="trade context is busy";                                     break;
      //---- mql4 errors
      case 4000: error_string="no error";                                                 break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed";                                     break;
      case 4110: error_string="longs are not allowed";                                    break;
      case 4111: error_string="shorts are not allowed";                                   break;
      case 4112: error_string="Template application error";                                                                                                            break;
      case 4113: error_string="Subwindow with the specified indicator not found";                                                                                      break;
      case 4114: error_string="Error when adding indicator to the chart";                                                                                              break;
      case 4115: error_string="Error when removing indicator from the chart";                                                                                          break;
      case 4116: error_string="The indicator not found in the specified chart";                                                                                        break;
      //-- Graphical objects
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      //-- MarketInfo
      case 4301: error_string="Unknown symbol";                                                                                                                        break;
      case 4302: error_string="The symbol not selected in MarketWatch";                                                                                                break;
      case 4303: error_string="Incorrect symbol property identifier";                                                                                                  break;
      case 4304: error_string="Unknown time of the last tick (no ticks)";                                                                                              break;
      //-- Access to history
      case 4401: error_string="Requested history not found!";                                                                                                          break;
      case 4402: error_string="Incorrect history property identifier";                                                                                                 break;
      //-- Global_Variables
      case 4501: error_string="Global variable of the client terminal not found";                                                                                      break;
      case 4502: error_string="Global variable of the client terminal with this name already exists";                                                                  break;
      case 4510: error_string="Failed to send the message";                                                                                                            break;
      case 4511: error_string="Failed to play the sound";                                                                                                              break;
      case 4512: error_string="Incorrect program property identifier";                                                                                                 break;
      case 4513: error_string="Incorrect terminal property identifier";                                                                                                break;
      case 4514: error_string="Failed to export the file by ftp";                                                                                                      break;
      //-- Buffers of custom indicators
      case 4601: error_string="Not enough memory to allocate indicator buffers";                                                                                       break;
      case 4602: error_string="Incorrect index of the custom indicator buffer";                                                                                        break;
      //-- Custom indicator properties
      case 4603: error_string="Incorrect custom indicator property identifier";                                                                                        break;
      //-- Account
      case 4701: error_string="Incorrect account property identifier";                                                                                                 break;
      case 4751: error_string="Incorrect trading property identifier";                                                                                                 break;
      case 4752: error_string="The Expert Advisor is not allowed to trade";                                                                                            break;
      case 4753: error_string="The position not found";                                                                                                                break;
      case 4754: error_string="The order not found";                                                                                                                   break;
      case 4755: error_string="The trade not found";                                                                                                                   break;
      case 4756: error_string="Failed to send the trade request";                                                                                                      break;
      //-- Indicators
      case 4801: error_string="Unknown symbol";                                                                                                                        break;
      case 4802: error_string="Unable to create the indicator";                                                                                                        break;
      case 4803: error_string="Not enough memory to add the indicator";                                                                                                break;
      case 4804: error_string="Unable to apply the indicator to another indicator";                                                                                    break;
      case 4805: error_string="Error when adding the indicator";                                                                                                       break;
      case 4806: error_string="Requested data not found";                                                                                                              break;
      case 4807: error_string="Incorrect indicator handle";                                                                                                            break;
      case 4808: error_string="Invalid number of parameters when creating the indicator";                                                                              break;
      case 4809: error_string="No parameters to create the indicator";                                                                                                 break;
      case 4810: error_string="Custom indicator name should be the first parameter in the array";                                                                      break;
      case 4811: error_string="Invalid parameter type in the array when creating the indicator";                                                                       break;
      case 4812: error_string="Incorrect index of the requested indicator buffer";                                                                                     break;
      //-- Depth of market
      case 4901: error_string="Unable to add the depth of market";                                                                                                     break;
      case 4902: error_string="Unable to delete the depth of market";                                                                                                  break;
      case 4903: error_string="Unable to get data from the depth of market";                                                                                           break;
      case 4904: error_string="Error when subscribing to get new data from the depth of market";                                                                       break;
      //-- File operations
      case 5001: error_string="The number of files open at the same time cannot exceed 64";                                                                            break;
      case 5002: error_string="Invalid file name";                                                                                                                     break;
      case 5003: error_string="File name too long";                                                                                                                    break;
      case 5004: error_string="File opening error";                                                                                                                    break;
      case 5005: error_string="Not enough memory to cache read";                                                                                                       break;
      case 5006: error_string="File deleting error";                                                                                                                   break;
      case 5007: error_string="The file with this handle has already been closed or has never been opened";                                                            break;
      case 5008: error_string="Incorrect file handle";                                                                                                                 break;
      case 5009: error_string="The file must be open for writing";                                                                                                     break;
      case 5010: error_string="The file must be open for reading";                                                                                                     break;
      case 5011: error_string="The file must be open in binary mode";                                                                                                  break;
      case 5012: error_string="The file must be open in text mode";                                                                                                    break;
      case 5013: error_string="The file must be open in text mode or CSV format";                                                                                      break;
      case 5014: error_string="The file must be open in CSV format";                                                                                                   break;
      case 5015: error_string="File reading error";                                                                                                                    break;
      case 5016: error_string="String size must be specified for the file that is open in binary mode";                                                                break;
      case 5017: error_string="There must be text file for string arrays and a binary file for all other arrays";                                                      break;
      case 5018: error_string="This is not a file, it is a directory";                                                                                                 break;
      case 5019: error_string="The file does not exist";                                                                                                               break;
      case 5020: error_string="The file cannot be rewritten";                                                                                                          break;
      case 5021: error_string="Incorrect directory name";                                                                                                              break;
      case 5022: error_string="The directory does not exist";                                                                                                          break;
      case 5023: error_string="This is not a directory, it is a file";                                                                                                 break;
      case 5024: error_string="The directory cannot be deleted";                                                                                                       break;
      case 5025: error_string="Failed to clear the directory (can happen if one or more files is blocked and the deletion was not successful)";                        break;
      //-- String formatting
      case 5030: error_string="No date in the string";                                                                                                                 break;
      case 5031: error_string="Incorrect date in the string";                                                                                                          break;
      case 5032: error_string="Incorrect time in the string";                                                                                                          break;
      case 5033: error_string="Error converting string to date";                                                                                                       break;
      case 5034: error_string="Not enough memory for the string";                                                                                                      break;
      case 5035: error_string="String length is less than expected";                                                                                                   break;
      case 5036: error_string="Number too large, bigger than ULONG_MAX";                                                                                               break;
      case 5037: error_string="Incorrect format string";                                                                                                               break;
      case 5038: error_string="The number of format specifiers is bigger than the number of parameters";                                                               break;
      case 5039: error_string="The number of parameters is bigger than the number of format specifiers";                                                               break;
      case 5040: error_string="Corrupted string type parameter";                                                                                                       break;
      case 5041: error_string="Position outside of the string";                                                                                                        break;
      case 5042: error_string="0 added to the end of the string, content-free operation";                                                                              break;
      case 5043: error_string="Unknown data type when converting to string";                                                                                           break;
      case 5044: error_string="Corrupted string object";                                                                                                               break;
      //-- Operations with arrays
      case 5050: error_string="Cannot copy incompatible arrays. String array can only be copied to another string array and numeric array to another numeric array";   break;
      case 5051: error_string="The receiving array is declared as AS_SERIES and its size is not sufficient";                                                           break;
      case 5052: error_string="Array too small, the starting position is outside of the array";                                                                        break;
      case 5053: error_string="Zero length array";                                                                                                                     break;
      case 5054: error_string="The array must be numeric";                                                                                                             break;
      case 5055: error_string="The array must be one-dimensional";                                                                                                     break;
      case 5056: error_string="The time series cannot be used";                                                                                                        break;
      case 5057: error_string="The array must be of the double type";                                                                                                  break;
      case 5058: error_string="The array must be of the float type";                                                                                                   break;
      case 5059: error_string="The array must be of the long type";                                                                                                    break;
      case 5060: error_string="The array must be of the int type";                                                                                                     break;
      case 5061: error_string="The array must be of the short type";                                                                                                   break;
      case 5062: error_string="The array must be of the char type";                                                                                                    break;
      //-- User errors
      default:   error_string="unknown error";
     }
//----
   return(error_string);
  }
//+------------------------------------------------------------------+
